diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-raw-socket-impl.h ns-3.39/src/internet/model/ipv4-raw-socket-impl.h
--- ns-3.38/src/internet/model/ipv4-raw-socket-impl.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-raw-socket-impl.h	2023-07-05 14:23:47.849427500 -0700
@@ -42,13 +42,13 @@
      */
     void SetNode(Ptr<Node> node);
 
-    enum Socket::SocketErrno GetErrno() const override;
+    Socket::SocketErrno GetErrno() const override;
 
     /**
      * \brief Get socket type (NS3_SOCK_RAW)
      * \return socket type
      */
-    enum Socket::SocketType GetSocketType() const override;
+    Socket::SocketType GetSocketType() const override;
 
     Ptr<Node> GetNode() const override;
     int Bind(const Address& address) override;
@@ -99,15 +99,15 @@
         uint16_t fromProtocol; /**< Protocol used */
     };
 
-    mutable enum Socket::SocketErrno m_err; //!< Last error number.
-    Ptr<Node> m_node;                       //!< Node
-    Ipv4Address m_src;                      //!< Source address.
-    Ipv4Address m_dst;                      //!< Destination address.
-    uint16_t m_protocol;                    //!< Protocol.
-    std::list<struct Data> m_recv;          //!< Packet waiting to be processed.
-    bool m_shutdownSend;                    //!< Flag to shutdown send capability.
-    bool m_shutdownRecv;                    //!< Flag to shutdown receive capability.
-    uint32_t m_icmpFilter;                  //!< ICMPv4 filter specification
+    mutable Socket::SocketErrno m_err; //!< Last error number.
+    Ptr<Node> m_node;                  //!< Node
+    Ipv4Address m_src;                 //!< Source address.
+    Ipv4Address m_dst;                 //!< Destination address.
+    uint16_t m_protocol;               //!< Protocol.
+    std::list<Data> m_recv;            //!< Packet waiting to be processed.
+    bool m_shutdownSend;               //!< Flag to shutdown send capability.
+    bool m_shutdownRecv;               //!< Flag to shutdown receive capability.
+    uint32_t m_icmpFilter;             //!< ICMPv4 filter specification
     bool m_iphdrincl; //!< Include IP Header information (a.k.a setsockopt (IP_HDRINCL))
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-routing-protocol.cc ns-3.39/src/internet/model/ipv4-routing-protocol.cc
--- ns-3.38/src/internet/model/ipv4-routing-protocol.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-routing-protocol.cc	2023-07-05 14:23:47.849427500 -0700
@@ -17,8 +17,6 @@
 
 #include "ipv4-routing-protocol.h"
 
-#include "ipv4-route.h"
-
 #include "ns3/assert.h"
 #include "ns3/log.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-routing-protocol.h ns-3.39/src/internet/model/ipv4-routing-protocol.h
--- ns-3.38/src/internet/model/ipv4-routing-protocol.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-routing-protocol.h	2023-07-05 14:23:47.849427500 -0700
@@ -126,10 +126,10 @@
     virtual bool RouteInput(Ptr<const Packet> p,
                             const Ipv4Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb) = 0;
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb) = 0;
 
     /**
      * \param interface the index of the interface we are being notified about
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-routing-table-entry.cc ns-3.39/src/internet/model/ipv4-routing-table-entry.cc
--- ns-3.38/src/internet/model/ipv4-routing-table-entry.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-routing-table-entry.cc	2023-07-05 14:23:47.849427500 -0700
@@ -99,14 +99,7 @@
 Ipv4RoutingTableEntry::IsHost() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_destNetworkMask == Ipv4Mask::GetOnes())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return m_destNetworkMask == Ipv4Mask::GetOnes();
 }
 
 Ipv4Address
@@ -127,14 +120,7 @@
 Ipv4RoutingTableEntry::IsDefault() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_dest == Ipv4Address::GetZero())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return m_dest == Ipv4Address::GetZero();
 }
 
 Ipv4Address
@@ -155,14 +141,7 @@
 Ipv4RoutingTableEntry::IsGateway() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_gateway == Ipv4Address::GetZero())
-    {
-        return false;
-    }
-    else
-    {
-        return true;
-    }
+    return m_gateway != Ipv4Address::GetZero();
 }
 
 Ipv4Address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-static-routing.cc ns-3.39/src/internet/model/ipv4-static-routing.cc
--- ns-3.38/src/internet/model/ipv4-static-routing.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-static-routing.cc	2023-07-05 14:23:47.853427400 -0700
@@ -26,9 +26,9 @@
 
 #include "ipv4-static-routing.h"
 
+#include "ipv4-route.h"
 #include "ipv4-routing-table-entry.h"
 
-#include "ns3/ipv4-route.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
 #include "ns3/node.h"
@@ -503,10 +503,10 @@
 Ipv4StaticRouting::RouteInput(Ptr<const Packet> p,
                               const Ipv4Header& ipHeader,
                               Ptr<const NetDevice> idev,
-                              UnicastForwardCallback ucb,
-                              MulticastForwardCallback mcb,
-                              LocalDeliverCallback lcb,
-                              ErrorCallback ecb)
+                              const UnicastForwardCallback& ucb,
+                              const MulticastForwardCallback& mcb,
+                              const LocalDeliverCallback& lcb,
+                              const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << ipHeader << ipHeader.GetSource() << ipHeader.GetDestination()
                          << idev << &ucb << &mcb << &lcb << &ecb);
@@ -558,7 +558,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, ipHeader, Socket::ERROR_NOROUTETOHOST);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv4-static-routing.h ns-3.39/src/internet/model/ipv4-static-routing.h
--- ns-3.38/src/internet/model/ipv4-static-routing.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv4-static-routing.h	2023-07-05 14:23:47.853427400 -0700
@@ -83,10 +83,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
 
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-address-generator.cc ns-3.39/src/internet/model/ipv6-address-generator.cc
--- ns-3.38/src/internet/model/ipv6-address-generator.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-address-generator.cc	2023-07-05 14:23:47.853427400 -0700
@@ -605,9 +605,8 @@
 {
     NS_LOG_FUNCTION(this << address << prefix);
 
-    Ipv6Address addr = address;
     NS_ABORT_MSG_UNLESS(
-        address == addr.CombinePrefix(prefix),
+        address == address.CombinePrefix(prefix),
         "Ipv6AddressGeneratorImpl::IsNetworkAllocated(): network address and mask don't match "
             << address << " " << prefix);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-end-point.cc ns-3.39/src/internet/model/ipv6-end-point.cc
--- ns-3.38/src/internet/model/ipv6-end-point.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-end-point.cc	2023-07-05 14:23:47.853427400 -0700
@@ -49,7 +49,7 @@
 }
 
 Ipv6Address
-Ipv6EndPoint::GetLocalAddress()
+Ipv6EndPoint::GetLocalAddress() const
 {
     return m_localAddr;
 }
@@ -73,7 +73,7 @@
 }
 
 Ipv6Address
-Ipv6EndPoint::GetPeerAddress()
+Ipv6EndPoint::GetPeerAddress() const
 {
     return m_peerAddr;
 }
@@ -91,7 +91,7 @@
 }
 
 Ptr<NetDevice>
-Ipv6EndPoint::GetBoundNetDevice()
+Ipv6EndPoint::GetBoundNetDevice() const
 {
     return m_boundnetdevice;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-end-point.h ns-3.39/src/internet/model/ipv6-end-point.h
--- ns-3.38/src/internet/model/ipv6-end-point.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-end-point.h	2023-07-05 14:23:47.853427400 -0700
@@ -62,7 +62,7 @@
      * \brief Get the local address.
      * \return the local address
      */
-    Ipv6Address GetLocalAddress();
+    Ipv6Address GetLocalAddress() const;
 
     /**
      * \brief Set the local address.
@@ -86,7 +86,7 @@
      * \brief Get the peer address.
      * \return the peer address
      */
-    Ipv6Address GetPeerAddress();
+    Ipv6Address GetPeerAddress() const;
 
     /**
      * \brief Get the peer port.
@@ -130,7 +130,7 @@
      *
      * \returns Pointer to interface.
      */
-    Ptr<NetDevice> GetBoundNetDevice();
+    Ptr<NetDevice> GetBoundNetDevice() const;
 
     /**
      * \brief Set the reception callback.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-extension.cc ns-3.39/src/internet/model/ipv6-extension.cc
--- ns-3.38/src/internet/model/ipv6-extension.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-extension.cc	2023-07-05 14:23:47.853427400 -0700
@@ -22,17 +22,14 @@
 #include "icmpv6-l4-protocol.h"
 #include "ipv6-extension-demux.h"
 #include "ipv6-extension-header.h"
+#include "ipv6-header.h"
+#include "ipv6-l3-protocol.h"
 #include "ipv6-option-demux.h"
 #include "ipv6-option.h"
-#include "udp-header.h"
+#include "ipv6-route.h"
 
 #include "ns3/assert.h"
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-l3-protocol.h"
-#include "ns3/ipv6-list-routing.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-static-routing.h"
 #include "ns3/log.h"
 #include "ns3/object-vector.h"
 #include "ns3/trace-source-accessor.h"
@@ -513,11 +510,16 @@
         }
         else if (nextHeader == Ipv6Header::IPV6_EXT_ROUTING)
         {
-            uint8_t buf[2];
+            Ptr<Ipv6ExtensionRoutingDemux> ipv6ExtensionRoutingDemux =
+                GetNode()->GetObject<Ipv6ExtensionRoutingDemux>();
+
+            uint8_t buf[4];
             p->CopyData(buf, sizeof(buf));
-            uint8_t numberAddress = buf[1] / 2;
-            Ipv6ExtensionLooseRoutingHeader* routingHeader = new Ipv6ExtensionLooseRoutingHeader();
-            routingHeader->SetNumberAddress(numberAddress);
+            uint8_t routingType = buf[2];
+
+            Ipv6ExtensionRoutingHeader* routingHeader =
+                ipv6ExtensionRoutingDemux->GetExtensionRoutingHeaderPtr(routingType);
+
             p->RemoveHeader(*routingHeader);
 
             nextHeader = routingHeader->GetNextHeader();
@@ -885,6 +887,12 @@
     return 0;
 }
 
+Ipv6ExtensionRoutingHeader*
+Ipv6ExtensionRouting::GetExtensionRoutingHeaderPtr()
+{
+    return nullptr;
+}
+
 uint8_t
 Ipv6ExtensionRouting::Process(Ptr<Packet>& packet,
                               uint8_t offset,
@@ -1014,15 +1022,30 @@
 Ptr<Ipv6ExtensionRouting>
 Ipv6ExtensionRoutingDemux::GetExtensionRouting(uint8_t typeRouting)
 {
-    for (Ipv6ExtensionRoutingList_t::iterator i = m_extensionsRouting.begin();
-         i != m_extensionsRouting.end();
-         i++)
+    for (const auto& extRouting : m_extensionsRouting)
     {
-        if ((*i)->GetTypeRouting() == typeRouting)
+        if (extRouting->GetTypeRouting() == typeRouting)
         {
-            return *i;
+            return extRouting;
         }
     }
+
+    return nullptr;
+}
+
+Ipv6ExtensionRoutingHeader*
+Ipv6ExtensionRoutingDemux::GetExtensionRoutingHeaderPtr(uint8_t typeRouting)
+{
+    NS_LOG_FUNCTION(this << typeRouting);
+
+    for (const auto& extRouting : m_extensionsRouting)
+    {
+        if (extRouting->GetTypeRouting() == typeRouting)
+        {
+            return extRouting->GetExtensionRoutingHeaderPtr();
+        }
+    }
+
     return nullptr;
 }
 
@@ -1059,6 +1082,12 @@
     return TYPE_ROUTING;
 }
 
+Ipv6ExtensionRoutingHeader*
+Ipv6ExtensionLooseRouting::GetExtensionRoutingHeaderPtr()
+{
+    return new Ipv6ExtensionLooseRoutingHeader();
+}
+
 uint8_t
 Ipv6ExtensionLooseRouting::Process(Ptr<Packet>& packet,
                                    uint8_t offset,
@@ -1089,9 +1118,7 @@
     // Get the number of routers' address field
     uint8_t buf[2];
     p->CopyData(buf, sizeof(buf));
-    uint8_t numberAddress = buf[1] / 2;
     Ipv6ExtensionLooseRoutingHeader routingHeader;
-    routingHeader.SetNumberAddress(numberAddress);
     p->RemoveHeader(routingHeader);
 
     if (nextHeader)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-extension.h ns-3.39/src/internet/model/ipv6-extension.h
--- ns-3.38/src/internet/model/ipv6-extension.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-extension.h	2023-07-05 14:23:47.853427400 -0700
@@ -20,6 +20,7 @@
 #ifndef IPV6_EXTENSION_H
 #define IPV6_EXTENSION_H
 
+#include "ipv6-extension-header.h"
 #include "ipv6-interface.h"
 
 #include "ns3/buffer.h"
@@ -515,6 +516,13 @@
      */
     virtual uint8_t GetTypeRouting() const;
 
+    /**
+     * \brief Get a pointer to a new routing extension header.
+     * The ownership is transferred to the caller.
+     * \return a pointer to a new routing extension header.
+     */
+    virtual Ipv6ExtensionRoutingHeader* GetExtensionRoutingHeaderPtr();
+
     uint8_t Process(Ptr<Packet>& packet,
                     uint8_t offset,
                     const Ipv6Header& ipv6Header,
@@ -569,6 +577,14 @@
     Ptr<Ipv6ExtensionRouting> GetExtensionRouting(uint8_t typeRouting);
 
     /**
+     * \brief Get a pointer to a new routing extension header corresponding
+     * to typeRouting. The ownership is transferred to the caller.
+     * \param typeRouting the number of the routing extension to retrieve
+     * \return a pointer to a new routing extension header matching IPv6 routing extension
+     */
+    Ipv6ExtensionRoutingHeader* GetExtensionRoutingHeaderPtr(uint8_t typeRouting);
+
+    /**
      * \brief Remove a routing extension from this demux.
      * \param extensionRouting pointer on the extension to remove
      */
@@ -632,6 +648,8 @@
      */
     uint8_t GetTypeRouting() const override;
 
+    Ipv6ExtensionRoutingHeader* GetExtensionRoutingHeaderPtr() override;
+
     uint8_t Process(Ptr<Packet>& packet,
                     uint8_t offset,
                     const Ipv6Header& ipv6Header,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6.h ns-3.39/src/internet/model/ipv6.h
--- ns-3.38/src/internet/model/ipv6.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6.h	2023-07-05 14:23:47.857427600 -0700
@@ -383,12 +383,14 @@
                       Ptr<Ipv6Route> route) = 0;
 
     /**
-     * \brief Register the IPv6 Extensions.
+     * \brief Register the IPv6 Extensions. Does nothing if the Extensions have been already
+     * registered.
      */
     virtual void RegisterExtensions() = 0;
 
     /**
-     * \brief Register the IPv6 Options.
+     * \brief Register the IPv6 Options. Does nothing if the Options have been already
+     * registered.
      */
     virtual void RegisterOptions() = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-header.h ns-3.39/src/internet/model/ipv6-header.h
--- ns-3.38/src/internet/model/ipv6-header.h	2023-03-16 20:54:51.628957000 -0700
+++ ns-3.39/src/internet/model/ipv6-header.h	2023-07-05 14:23:47.853427400 -0700
@@ -20,7 +20,6 @@
 #ifndef IPV6_HEADER_H
 #define IPV6_HEADER_H
 
-#include "ns3/deprecated.h"
 #include "ns3/header.h"
 #include "ns3/ipv6-address.h"
 
@@ -89,7 +88,7 @@
         IPV6_EXT_ROUTING = 43,
         IPV6_EXT_FRAGMENTATION = 44,
         IPV6_EXT_CONFIDENTIALITY = 50,
-        IPV6_EXT_AUTHENTIFICATION = 51,
+        IPV6_EXT_AUTHENTICATION = 51,
         IPV6_ICMPV6 = 58,
         IPV6_EXT_END = 59,
         IPV6_EXT_DESTINATION = 60,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-l3-protocol.cc ns-3.39/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.38/src/internet/model/ipv6-l3-protocol.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-l3-protocol.cc	2023-07-05 14:23:47.853427400 -0700
@@ -22,20 +22,19 @@
 #include "icmpv6-l4-protocol.h"
 #include "ipv6-autoconfigured-prefix.h"
 #include "ipv6-extension-demux.h"
-#include "ipv6-extension-header.h"
 #include "ipv6-extension.h"
 #include "ipv6-interface.h"
 #include "ipv6-option-demux.h"
 #include "ipv6-option.h"
 #include "ipv6-raw-socket-factory-impl.h"
 #include "ipv6-raw-socket-impl.h"
+#include "ipv6-route.h"
+#include "ipv6-routing-protocol.h"
 #include "loopback-net-device.h"
 #include "ndisc-cache.h"
 
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-routing-protocol.h"
 #include "ns3/log.h"
 #include "ns3/mac16-address.h"
 #include "ns3/mac64-address.h"
@@ -91,7 +90,7 @@
                           MakeBooleanChecker())
             .AddAttribute("StrongEndSystemModel",
                           "Reject packets for an address not configured on the interface they're "
-                          "coming from (RFC1222).",
+                          "coming from (RFC1122, section 3.3.4.2).",
                           BooleanValue(true),
                           MakeBooleanAccessor(&Ipv6L3Protocol::m_strongEndSystemModel),
                           MakeBooleanChecker())
@@ -134,6 +133,10 @@
 
     Ptr<Ipv6RawSocketFactoryImpl> rawFactoryImpl = CreateObject<Ipv6RawSocketFactoryImpl>();
     AggregateObject(rawFactoryImpl);
+    m_ucb = MakeCallback(&Ipv6L3Protocol::IpForward, this);
+    m_mcb = MakeCallback(&Ipv6L3Protocol::IpMulticastForward, this);
+    m_lcb = MakeCallback(&Ipv6L3Protocol::LocalDeliver, this);
+    m_ecb = MakeCallback(&Ipv6L3Protocol::RouteInputError, this);
 }
 
 Ipv6L3Protocol::~Ipv6L3Protocol()
@@ -1160,39 +1163,41 @@
 
     for (uint32_t j = 0; j < GetNInterfaces(); j++)
     {
-        if (j == interface || !m_strongEndSystemModel)
+        for (uint32_t i = 0; i < GetNAddresses(j); i++)
         {
-            for (uint32_t i = 0; i < GetNAddresses(j); i++)
+            Ipv6InterfaceAddress iaddr = GetAddress(j, i);
+            Ipv6Address addr = iaddr.GetAddress();
+            if (addr == hdr.GetDestination())
             {
-                Ipv6InterfaceAddress iaddr = GetAddress(j, i);
-                Ipv6Address addr = iaddr.GetAddress();
-                if (addr == hdr.GetDestination())
+                if (j == interface)
                 {
-                    if (j == interface)
-                    {
-                        NS_LOG_LOGIC("For me (destination " << addr << " match)");
-                    }
-                    else
-                    {
-                        NS_LOG_LOGIC("For me (destination " << addr
-                                                            << " match) on another interface "
-                                                            << hdr.GetDestination());
-                    }
+                    NS_LOG_LOGIC("For me (destination " << addr << " match)");
+                    LocalDeliver(packet, hdr, interface);
+                    return;
+                }
+                else if (!m_strongEndSystemModel)
+                {
+                    NS_LOG_LOGIC("For me (destination "
+                                 << addr << " match) on another interface with Weak ES Model"
+                                 << hdr.GetDestination());
                     LocalDeliver(packet, hdr, interface);
                     return;
                 }
-                NS_LOG_LOGIC("Address " << addr << " not a match");
+                else
+                {
+                    NS_LOG_LOGIC("For me (destination "
+                                 << addr
+                                 << " match) on another interface with Strong ES Model - discarding"
+                                 << hdr.GetDestination());
+                    m_dropTrace(hdr, packet, DROP_NO_ROUTE, this, interface);
+                    return;
+                }
             }
+            NS_LOG_LOGIC("Address " << addr << " not a match");
         }
     }
 
-    if (!m_routingProtocol->RouteInput(packet,
-                                       hdr,
-                                       device,
-                                       MakeCallback(&Ipv6L3Protocol::IpForward, this),
-                                       MakeCallback(&Ipv6L3Protocol::IpMulticastForward, this),
-                                       MakeCallback(&Ipv6L3Protocol::LocalDeliver, this),
-                                       MakeCallback(&Ipv6L3Protocol::RouteInputError, this)))
+    if (!m_routingProtocol->RouteInput(packet, hdr, device, m_ucb, m_mcb, m_lcb, m_ecb))
     {
         NS_LOG_WARN("No route found for forwarding packet.  Drop.");
         // Drop trace and ICMPs are courtesy of RouteInputError
@@ -1383,7 +1388,7 @@
         NS_LOG_WARN("TTL exceeded.  Drop.");
         m_dropTrace(ipHeader, packet, DROP_TTL_EXPIRED, this, 0);
         // Do not reply to multicast IPv6 address
-        if (ipHeader.GetDestination().IsMulticast() == false)
+        if (!ipHeader.GetDestination().IsMulticast())
         {
             packet->AddHeader(ipHeader);
             GetIcmpv6()->SendErrorTimeExceeded(packet,
@@ -1579,7 +1584,7 @@
 
                 m_localDeliverTrace(ip, p, iif);
 
-                enum IpL4Protocol::RxStatus status = protocol->Receive(p, ip, GetInterface(iif));
+                IpL4Protocol::RxStatus status = protocol->Receive(p, ip, GetInterface(iif));
 
                 switch (status)
                 {
@@ -1652,6 +1657,10 @@
 void
 Ipv6L3Protocol::RegisterExtensions()
 {
+    if (m_node->GetObject<Ipv6ExtensionDemux>())
+    {
+        return;
+    }
     Ptr<Ipv6ExtensionDemux> ipv6ExtensionDemux = CreateObject<Ipv6ExtensionDemux>();
     ipv6ExtensionDemux->SetNode(m_node);
 
@@ -1688,6 +1697,10 @@
 void
 Ipv6L3Protocol::RegisterOptions()
 {
+    if (m_node->GetObject<Ipv6OptionDemux>())
+    {
+        return;
+    }
     Ptr<Ipv6OptionDemux> ipv6OptionDemux = CreateObject<Ipv6OptionDemux>();
     ipv6OptionDemux->SetNode(m_node);
 
@@ -1777,11 +1790,7 @@
     Ipv6RegisteredMulticastAddressKey_t key = std::make_pair(address, interface);
     Ipv6RegisteredMulticastAddressCIter_t iter = m_multicastAddresses.find(key);
 
-    if (iter == m_multicastAddresses.end())
-    {
-        return false;
-    }
-    return true;
+    return iter != m_multicastAddresses.end();
 }
 
 bool
@@ -1792,11 +1801,7 @@
     Ipv6RegisteredMulticastAddressNoInterfaceCIter_t iter =
         m_multicastAddressesNoInterface.find(address);
 
-    if (iter == m_multicastAddressesNoInterface.end())
-    {
-        return false;
-    }
-    return true;
+    return iter != m_multicastAddressesNoInterface.end();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-l3-protocol.h ns-3.39/src/internet/model/ipv6-l3-protocol.h
--- ns-3.38/src/internet/model/ipv6-l3-protocol.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-l3-protocol.h	2023-07-05 14:23:47.853427400 -0700
@@ -23,6 +23,7 @@
 #include "ns3/ipv6-address.h"
 #include "ns3/ipv6-header.h"
 #include "ns3/ipv6-pmtu-cache.h"
+#include "ns3/ipv6-routing-protocol.h"
 #include "ns3/ipv6.h"
 #include "ns3/net-device.h"
 #include "ns3/traced-callback.h"
@@ -367,14 +368,7 @@
                                      Ipv6Prefix mask,
                                      Ipv6Address defaultRouter);
 
-    /**
-     * \brief Register the IPv6 Extensions.
-     */
     void RegisterExtensions() override;
-
-    /**
-     * \brief Register the IPv6 Options.
-     */
     void RegisterOptions() override;
 
     /**
@@ -836,6 +830,11 @@
      * \brief List of multicast IP addresses of interest for all the interfaces.
      */
     Ipv6RegisteredMulticastAddressNoInterface_t m_multicastAddressesNoInterface;
+
+    Ipv6RoutingProtocol::UnicastForwardCallback m_ucb;   ///< Unicast forward callback
+    Ipv6RoutingProtocol::MulticastForwardCallback m_mcb; ///< Multicast forward callback
+    Ipv6RoutingProtocol::LocalDeliverCallback m_lcb;     ///< Local delivery callback
+    Ipv6RoutingProtocol::ErrorCallback m_ecb;            ///< Error callback
 };
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-list-routing.cc ns-3.39/src/internet/model/ipv6-list-routing.cc
--- ns-3.38/src/internet/model/ipv6-list-routing.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-list-routing.cc	2023-07-05 14:23:47.853427400 -0700
@@ -18,9 +18,9 @@
 
 #include "ipv6-list-routing.h"
 
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-static-routing.h"
-#include "ns3/ipv6.h"
+#include "ipv6-route.h"
+#include "ipv6.h"
+
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/simulator.h"
@@ -74,7 +74,7 @@
 Ipv6ListRouting::RouteOutput(Ptr<Packet> p,
                              const Ipv6Header& header,
                              Ptr<NetDevice> oif,
-                             enum Socket::SocketErrno& sockerr)
+                             Socket::SocketErrno& sockerr)
 {
     NS_LOG_FUNCTION(this << header.GetDestination() << header.GetSource() << oif);
     Ptr<Ipv6Route> route;
@@ -105,10 +105,10 @@
 Ipv6ListRouting::RouteInput(Ptr<const Packet> p,
                             const Ipv6Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb)
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(p << header << idev);
     NS_LOG_LOGIC("RouteInput logic for node: " << m_ipv6->GetObject<Node>()->GetId());
@@ -120,7 +120,7 @@
 
     // Check if input device supports IP forwarding
     uint32_t iif = m_ipv6->GetInterfaceForDevice(idev);
-    if (m_ipv6->IsForwarding(iif) == false)
+    if (!m_ipv6->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, header, Socket::ERROR_NOROUTETOHOST);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-list-routing.h ns-3.39/src/internet/model/ipv6-list-routing.h
--- ns-3.38/src/internet/model/ipv6-list-routing.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-list-routing.h	2023-07-05 14:23:47.853427400 -0700
@@ -95,10 +95,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv6Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv6InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-packet-filter.cc ns-3.39/src/internet/model/ipv6-packet-filter.cc
--- ns-3.38/src/internet/model/ipv6-packet-filter.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-packet-filter.cc	2023-07-05 14:23:47.853427400 -0700
@@ -26,8 +26,6 @@
 
 #include "ns3/enum.h"
 #include "ns3/log.h"
-#include "ns3/tcp-header.h"
-#include "ns3/udp-header.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-packet-probe.cc ns-3.39/src/internet/model/ipv6-packet-probe.cc
--- ns-3.38/src/internet/model/ipv6-packet-probe.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-packet-probe.cc	2023-07-05 14:23:47.853427400 -0700
@@ -21,7 +21,7 @@
  * Adapted to Ipv6 by: Tommaso Pecorella (tommaso.pecorella@unifi.it)
  */
 
-#include "ns3/ipv6-packet-probe.h"
+#include "ipv6-packet-probe.h"
 
 #include "ns3/config.h"
 #include "ns3/log.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-queue-disc-item.cc ns-3.39/src/internet/model/ipv6-queue-disc-item.cc
--- ns-3.38/src/internet/model/ipv6-queue-disc-item.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-queue-disc-item.cc	2023-07-05 14:23:47.853427400 -0700
@@ -17,9 +17,10 @@
 
 #include "ipv6-queue-disc-item.h"
 
+#include "tcp-header.h"
+#include "udp-header.h"
+
 #include "ns3/log.h"
-#include "ns3/tcp-header.h"
-#include "ns3/udp-header.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-raw-socket-impl.cc ns-3.39/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.38/src/internet/model/ipv6-raw-socket-impl.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-raw-socket-impl.cc	2023-07-05 14:23:47.853427400 -0700
@@ -22,18 +22,18 @@
 #include "icmpv6-header.h"
 #include "icmpv6-l4-protocol.h"
 #include "ipv6-l3-protocol.h"
+#include "ipv6-packet-info-tag.h"
+#include "ipv6-route.h"
+#include "ipv6-routing-protocol.h"
 
 #include "ns3/inet6-socket-address.h"
-#include "ns3/ipv6-packet-info-tag.h"
-#include "ns3/ipv6-route.h"
-#include "ns3/ipv6-routing-protocol.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
 #include "ns3/uinteger.h"
 
 #ifdef __WIN32__
-#include "ns3/win32-internet.h"
+#include "win32-internet.h"
 #else
 #include <netinet/in.h>
 #include <sys/socket.h>
@@ -100,14 +100,14 @@
     return m_node;
 }
 
-enum Socket::SocketErrno
+Socket::SocketErrno
 Ipv6RawSocketImpl::GetErrno() const
 {
     NS_LOG_FUNCTION(this);
     return m_err;
 }
 
-enum Socket::SocketType
+Socket::SocketType
 Ipv6RawSocketImpl::GetSocketType() const
 {
     return NS3_SOCK_RAW;
@@ -510,11 +510,7 @@
 bool
 Ipv6RawSocketImpl::SetAllowBroadcast(bool allowBroadcast)
 {
-    if (!allowBroadcast)
-    {
-        return false;
-    }
-    return true;
+    return allowBroadcast;
 }
 
 bool
